local LBI = LibStub("LibBossIDs-1.0")

local frame = _G.BattleStandardReminder or CreateFrame("Frame")
_G.BattleStandardReminder = frame

local GetTime=GetTime
local UnitGUID=UnitGUID
local UnitHealth,UnitHealthMax=UnitHealth,UnitHealthMax
local UnitExists,UnitIsTappedByPlayer=UnitExists,UnitIsTappedByPlayer
local tonumber = tonumber
local pairs = pairs
local wipe = wipe

local guids = setmetatable({}, {
      __index = function(self, key)
         local guid = tonumber(key:sub(-13, -9), 16) or 0
         self[key]=LBI.BossIDs[guid or 0] or false
         -- print(guid, self[key])
         return self[key]
      end
})

local lastWarn = 0

local partyMembers = {"party1","party2","party3","party4"}

local function check(unit)
	if UnitIsTappedByPlayer(unit) and guids[UnitGUID(unit)] then
		-- yes!
	else
		return	-- nope
	end

	local health = UnitHealth(unit) / UnitHealthMax(unit)
	if health < 0.3 and health >0.01 then  -- >0.01 = dont scream about corpses
		if GetTime()>lastWarn+120 then
-- GLOBALS: print, format, UnitName, UnitIsInMyGuild, UnitIsPartyLeader, SendChatMessage		
			local msg = format("GuildStandardReminder: %s is at %.0f%%", UnitName(unit), 
				UnitHealth(unit) / UnitHealthMax(unit) * 100
			)
			local numGuildies=1
			for k,v in pairs(partyMembers) do
				if UnitIsInMyGuild(v) then
					numGuildies=numGuildies+1
				end
			end
			if numGuildies>=3 and UnitIsPartyLeader("player") then -- 3 including myself
				SendChatMessage(msg, "party")
			else
				print(msg)
			end
			lastWarn=GetTime()
		end
	  
	end


end

function frame:UNIT_HEALTH(event,unit)
   return check(unit)
end

function frame:UNIT_HEALTH_FREQUENT(event,unit)	-- need to listen to this for boss1..bossN
	return check(unit)
end

function frame:UNIT_TARGET(event,srcunit)
   local unit = srcunit.."target"
   if UnitExists(unit) then
      return check(unit)
   end
end

function frame:ZONE_CHANGED(event)
   wipe(guids)
end



frame:SetScript("OnEvent", function(self,event,...)
      return self[event](self,event,...)
   end
)

function frame:PLAYER_LEVEL_UP()
-- GLOBALS: UnitLevel
	if UnitLevel("player")>=81 then		
		frame:RegisterEvent("UNIT_HEALTH")
		frame:RegisterEvent("UNIT_HEALTH_FREQUENT")
		frame:RegisterEvent("UNIT_TARGET")
		frame:RegisterEvent("ZONE_CHANGED")
	end
end

frame:RegisterEvent("PLAYER_LEVEL_UP")
frame:PLAYER_LEVEL_UP()
